require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/admin/ldap_configs', type: :request do
  let(:valid_attributes) { FactoryBot.attributes_for(:ldap_config) }
  let(:invalid_attributes) { FactoryBot.attributes_for(:ldap_config, host: nil) }

  let(:user) { FactoryBot.create(:user) }
  before :each do
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Admin::LdapConfig.create! valid_attributes
      get admin_ldap_configs_url
      expect(response).to be_successful
    end
  end

  # describe 'GET /show' do
  #   it 'renders a successful response' do
  #     ldap_config = LdapConfig.create! valid_attributes
  #     get ldap_config_url(ldap_config)
  #     expect(response).to be_successful
  #   end
  # end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_admin_ldap_config_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      ldap_config = Admin::LdapConfig.create! valid_attributes
      get edit_admin_ldap_config_url(ldap_config)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new LdapConfig' do
        expect {
          post admin_ldap_configs_url, params: { admin_ldap_config: valid_attributes }
        }.to change(Admin::LdapConfig, :count).by(1)
      end

      it 'redirects to the created ldap_config' do
        post admin_ldap_configs_url, params: { admin_ldap_config: valid_attributes }
        expect(response).to redirect_to(admin_ldap_configs_url)
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new LdapConfig' do
        expect {
          post admin_ldap_configs_url, params: { admin_ldap_config: invalid_attributes }
        }.to change(Admin::LdapConfig, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post admin_ldap_configs_url, params: { admin_ldap_config: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) do
        { name: 'LDap2', host: 'ldap2.domain.fr', port: 389, base_dn: 'ou=people,dc=domain,dc=fr',
          attr_uid: 'uid2', attr_email: 'mail2', attr_lastname: 'sn2' }
      end

      it 'updates the requested ldap_config' do
        ldap_config = Admin::LdapConfig.create! valid_attributes
        patch admin_ldap_config_url(ldap_config), params: { admin_ldap_config: new_attributes }
        ldap_config.reload

        expect(ldap_config.name).to eq 'LDap2'
        expect(ldap_config.host).to eq 'ldap2.domain.fr'
        expect(ldap_config.attr_uid).to eq 'uid2'
        expect(ldap_config.attr_email).to eq 'mail2'
      end

      it 'redirects to the ldap_config' do
        ldap_config = Admin::LdapConfig.create! valid_attributes
        patch admin_ldap_config_url(ldap_config), params: { admin_ldap_config: new_attributes }
        ldap_config.reload
        expect(response).to redirect_to(admin_ldap_configs_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        ldap_config = Admin::LdapConfig.create! valid_attributes
        patch admin_ldap_config_url(ldap_config), params: { admin_ldap_config: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested ldap_config' do
      ldap_config = Admin::LdapConfig.create! valid_attributes
      expect {
        delete admin_ldap_config_url(ldap_config)
      }.to change(Admin::LdapConfig, :count).by(-1)
    end

    it 'redirects to the ldap_configs list' do
      ldap_config = Admin::LdapConfig.create! valid_attributes
      delete admin_ldap_config_url(ldap_config)
      expect(response).to redirect_to(admin_ldap_configs_url)
    end
  end

  describe 'GET ldap_config_test' do
    # context 'with valid connection parameters : connection succed' do
    #   it 'renders a successful response' do
    #     ldap_config = Admin::LdapConfig.create! valid_attributes
    #     get ldap_config_test_url, params: {id: ldap_config.id}, xhr: true

    #     expect(response.body).to include 'succeed'
    #     expect(response).to be_successful
    #   end
    # end

    context 'with invalid connection parameters' do
      it 'renders a successful response : connection failed' do
        ldap_config = Admin::LdapConfig.create! valid_attributes
        ldap_config.host = 'ldap2.enit.fr'
        ldap_config.save!
        get admin_ldap_config_test_url, params: {id: ldap_config.id}, xhr: true

        expect(response.body).to include 'failed'
        expect(response).to be_successful
      end
    end
  end
end
